﻿    //Future releases will allow adding of addional morphs... still gotta figua those out.

using UnityEngine;
using SimpleJSON;
using System;
using MVR.FileManagementSecure;
using UnityEngine.UI;
using System.Collections.Generic;
using System.Linq;
using System.Collections;
using UnityStandardAssets.ImageEffects;


//using UnityEngine.UI;
//using System.Collections;
//using System.Collections.Generic;
//using System.Linq;
//using System.Runtime;
//using Battlehub.RTSaveLoad;
//using System.Reflection.Emit;
//using Leap.Unity;
//using System.IO;
//using System.Reflection;
//using System.Security.Policy;
//using UnityEngine.UI.Extensions;
//using GPUTools.Cloth.Scripts.Runtime.Commands;

//Custom/Atom/Person/Morphs/female_genitalia/AWWalker/AWWalker_GEN_Morphs3.0/AWW-LabiaMin-Swell_01.vmi

namespace AWWalker
{
    public class GenitalMultiPass : MVRScript
    {
        //SPECIFICS
        private bool DebugBuild = false;

        protected const string gmpversion = "17.0.1";
        protected const int GMP_VERSION = 17;
        protected const string isDev = "Release";
        protected const string _saveExt = "json";
        protected const string PUBLISH_DATE = "2023.03.17";
        private const string _gmpSavePath = "Saves\\PluginData\\AWWalker\\AWWMultiPass";
        private const string _gmpLoadPath = "Saves\\PluginData\\AWWalker";

        //GLOBAL STATICS
        protected Color cClear = Color.clear;
        protected Color cBlue = Color.blue;
        protected Color cWhite = Color.white;
        protected Color cRed = Color.red;
        protected Color cCyan = Color.cyan;
        protected Color cBlack = Color.black;
        protected Color cGray = Color.gray;
        protected Color cGreen = Color.green;
        protected Color cYellow = Color.yellow;
        protected Color cMagenta = Color.magenta;


        protected bool isEnabled = true;


        //MEASURES
        private static FreeControllerV3 chest;
        private static FreeControllerV3 lKnee;
        private static FreeControllerV3 rKnee;

        private bool rightSide = true;
        private bool leftSide = false;

        protected JSONStorableBool CurveEnabled;
        protected JSONStorableBool sIsEnabled;

        private DAZMorph HoodModMorph;
        protected JSONStorableFloat HoodModMorphChangeMin;
        protected JSONStorableFloat HoodModMorphChangeMax;

        private DAZMorph labiaMajoraMorph;
        protected JSONStorableFloat labiaMajoraMorphChangeMin;
        protected JSONStorableFloat labiaMajoraMorphChangeMax;

        private DAZMorph LabMajRMidMorph;
        protected JSONStorableFloat LabMajRMidMorphChangeMin;
        protected JSONStorableFloat LabMajRMidMorphChangeMax;

        private DAZMorph LabMajLUpMorph;
        protected JSONStorableFloat LabMajLUpMorphChangeMin;
        protected JSONStorableFloat LabMajLUpMorphChangeMax;

        private DAZMorph LabMajLMidMorph;
        protected JSONStorableFloat LabMajLMidMorphChangeMin;
        protected JSONStorableFloat LabMajLMidMorphChangeMax;

        private DAZMorph LabMajLLowMorph;
        protected JSONStorableFloat LabMajLLowMorphChangeMin;
        protected JSONStorableFloat LabMajLLowMorphChangeMax;

        private DAZMorph LabMinRMidMorph;
        protected JSONStorableFloat LabMinRMidMorphChangeMin;
        protected JSONStorableFloat LabMinRMidMorphChangeMax;

        private DAZMorph LabMinRUpMorph;
        protected JSONStorableFloat LabMinRUpMorphChangeMin;
        protected JSONStorableFloat LabMinRUpMorphChangeMax;

        private DAZMorph LabMinLLowMorph;
        protected JSONStorableFloat LabMinLLowMorphChangeMin;
        protected JSONStorableFloat LabMinLLowMorphChangeMax;

        private DAZMorph LabMinLUpMorph;
        protected JSONStorableFloat LabMinLUpMorphChangeMin;
        protected JSONStorableFloat LabMinLUpMorphChangeMax;

        private DAZMorph LabMajRLowMorph;
        protected JSONStorableFloat LabMajRLowMorphChangeMin;
        protected JSONStorableFloat LabMajRLowMorphChangeMax;

        private DAZMorph LabMinRLowMorph;
        protected JSONStorableFloat LabMinRLowMorphChangeMin;
        protected JSONStorableFloat LabMinRLowMorphChangeMax;

        private DAZMorph LabMajRUpMorph;
        protected JSONStorableFloat LabMajRUpMorphChangeMin;
        protected JSONStorableFloat LabMajRUpMorphChangeMax;

        private DAZMorph LabMinLMidMorph;
        protected JSONStorableFloat LabMinLMidMorphChangeMin;
        protected JSONStorableFloat LabMinLMidMorphChangeMax;

        private DAZMorph labiaMinoraMorph;
        protected JSONStorableFloat labiaMinoraMorphChangeMin;
        protected JSONStorableFloat labiaMinoraMorphChangeMax;

        private DAZMorph AWW_Majora_LeftUpperTopMorph;
        protected JSONStorableFloat AWW_Majora_LeftUpperTopMorphChangeMin;
        protected JSONStorableFloat AWW_Majora_LeftUpperTopMorphChangeMax;

        private DAZMorph AWW_Majora_RightUpperTopMorph;
        protected JSONStorableFloat AWW_Majora_RightUpperTopMorphChangeMin;
        protected JSONStorableFloat AWW_Majora_RightUpperTopMorphChangeMax;

        private DAZMorph AWW_VagInternal_Size2;
        protected JSONStorableFloat AWW_VagInternal_Size2ChangeMin;
        protected JSONStorableFloat AWW_VagInternal_Size2ChangeMax;

        private DAZMorph AWW_Clitoris_Front_Back;
        protected JSONStorableFloat AWW_Clitoris_Front_BackMin;
        protected JSONStorableFloat AWW_Clitoris_Front_BackRange;

        private DAZMorph AWW_Clitoris_HoodBack;
        protected JSONStorableFloat AWW_Clitoris_HoodBackRange;

        private DAZMorph AWW_Clitoris_Size;
        protected JSONStorableFloat AWW_Clitoris_SizeRange;

        private DAZMorph AWW_Clitoris_HoodSize;
        protected JSONStorableFloat AWW_Clitoris_HoodSizeRange;

        private DAZMorph AWW_00_KegelMorph;
        protected JSONStorableFloat AWW_00_KegelMin;
        protected JSONStorableFloat AWW_00_KegelMax;

        private DAZMorph AWW_Anus_SpreadGape02Morph;
        protected JSONStorableFloat AWW_Anus_SpreadGape02Min;
        protected JSONStorableFloat AWW_Anus_SpreadGape02Max;

        private DAZMorph AWW_GenLabiaMajoraClosedAndSmoothMorph;
        protected JSONStorableFloat AWW_GenLabiaMajoraClosedAndSmoothMorphMin;
        protected JSONStorableFloat AWW_GenLabiaMajoraClosedAndSmoothMorphMax;

        private DAZMorph AWW_PuffyMajora_1Morph;
        protected JSONStorableFloat AWW_PuffyMajora_1Range;

        protected JSONStorableFloat OverallIntensity;
        private DAZMorph AWWLabiaMinSwell01Morph;
        protected JSONStorableFloat AWWLabiaMinSwell01Range;

        protected JSONStorableBool StaticMinApplication;
        protected JSONStorableBool StaticMaxApplication;




        public override void Init()
        {
            findMorphs();
            registerJSONParams();
            buildUI();


        }
        private void findMorphs()
        {
            try
            {

                if (containingAtom.type != "Person")
                {
                    SuperController.LogError($"Plugin for use with 'Person' atom, not '{containingAtom.type}'");
                    return;
                }
                pluginLabelJSON.val = "Multi Pass - AWWalker version:" + gmpversion;
                JSONStorable js = containingAtom.GetStorableByID("geometry");

                if (js != null)
                {
                    DAZCharacterSelector dcs = js as DAZCharacterSelector;
                    GenerateDAZMorphsControlUI morphUI = dcs.morphsControlUI;
                    if (morphUI != null)
                    {
                        //
                        try
                        {
                            AWW_VagInternal_Size2 = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/AWW_VagInternal_Size2.vmi");
                            if (AWW_VagInternal_Size2 == null)
                            {
                                SuperController.LogError("Couldn't find morph 'AWW_VagInternal_Size2'");
                                AWW_VagInternal_Size2 = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            AWW_PuffyMajora_1Morph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/AWW_PuffyMajora_1.vmi");
                            if (AWW_PuffyMajora_1Morph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'AWW_PuffyMajora_1Morph'");
                                AWW_PuffyMajora_1Morph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            AWW_GenLabiaMajoraClosedAndSmoothMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources_Pak2.2:/Custom/Atom/Person/Morphs/female_genitalia/AWWalker/AWWalker_GEN_Morphs3.0/g2fGen-LabiaMajoraClosedAndSmooth.vmi");
                            if (AWW_GenLabiaMajoraClosedAndSmoothMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'AWW_GenLabiaMajoraClosedAndSmoothMorph'");
                                AWW_GenLabiaMajoraClosedAndSmoothMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            AWW_Clitoris_Size = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/AWW_Clitoris_Size.vmi");
                            if (AWW_Clitoris_Size == null)
                            {
                                SuperController.LogError("Couldn't find morph ' AWW_Clitoris_Size'");
                                AWW_Clitoris_Size = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            AWW_Clitoris_HoodSize = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/AWW_Clitoris_HoodSize.vmi");
                            if (AWW_Clitoris_HoodSize == null)
                            {
                                SuperController.LogError("Couldn't find morph ' AWW_Clitoris_HoodSize'");
                                AWW_Clitoris_HoodSize = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            AWW_Clitoris_HoodBack = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/AWW_Clitoris_HoodBack.vmi");
                            if (AWW_Clitoris_HoodBack == null)
                            {
                                SuperController.LogError("Couldn't find morph ' AWW_Clitoris_HoodBack'");
                                AWW_Clitoris_HoodBack = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            AWW_Clitoris_Front_Back = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/AWW_Clitoris_Front_Back.vmi");
                            if (AWW_Clitoris_Front_Back == null)
                            {
                                SuperController.LogError("Couldn't find morph ' AWW_Clitoris_Front_Back'");
                                AWW_Clitoris_Front_Back = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            AWW_Majora_LeftUpperTopMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/AWW_Majora_LeftUpperTop.vmi");
                            if (AWW_Majora_LeftUpperTopMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'AWW_Majora_LeftUpperTop'");
                                AWW_Majora_LeftUpperTopMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            AWW_Majora_RightUpperTopMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/AWW_Majora_RightUpperTop.vmi");
                            if (AWW_Majora_RightUpperTopMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'AWW_Majora_RightUpperTop'");
                                AWW_Majora_RightUpperTopMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            labiaMinoraMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia minora-size.vmi");
                            if (labiaMinoraMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'Labia minora-size'");
                                labiaMinoraMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            HoodModMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/HoodMod.vmi");
                            if (HoodModMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'HoodMod'");
                                HoodModMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            labiaMajoraMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia majora-relaxation.vmi");
                            if (labiaMajoraMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'Labia majora-relaxation'");
                                labiaMajoraMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            LabMajRMidMorph = morphUI.GetMorphByDisplayName("Labia majora-spread-RMid");
                            if (LabMajRMidMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'Labia majora-spread-RMid'");
                                LabMajRMidMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            LabMajLUpMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia majora-spread-LUp.vmi");
                            if (LabMajLUpMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'Labia majora-spread-LUp'");
                                LabMajLUpMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            LabMajLMidMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia majora-spread-LMid.vmi");
                            if (LabMajLMidMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'Labia majora-spread-LMid'");
                                LabMajLMidMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            LabMajLLowMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia majora-spread-LLow.vmi");
                            if (LabMajLLowMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'Labia majora-spread-LLow'");
                                LabMajLLowMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            LabMinRMidMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia minora-spread-RMid.vmi");
                            if (LabMinRMidMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'Labia minora-spread-RMid'");
                                LabMinRMidMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {                            //(* needsStore fix*)
                            LabMinRUpMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia minora-spread-RUp.vmi");
                            if (LabMinRUpMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'Labia minora-spread-RUp'");
                                LabMinRUpMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            LabMinLLowMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia minora-spread-LLow.vmi");
                            if (LabMinLLowMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'Labia minora-spread-LLow'");
                                LabMinLLowMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            LabMinLUpMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia minora-spread-LUp.vmi");
                            if (LabMinLUpMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'Labia minora-spread-LUp'");
                                LabMinLUpMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            LabMajRLowMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia majora-spread-RLow.vmi");
                            if (LabMajRLowMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'Labia majora-spread-RLow'");
                                LabMajRLowMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            LabMinRLowMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia minora-spread-RLow.vmi");
                            if (LabMinRLowMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'Labia minora-spread-RLow'");
                                LabMinRLowMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            LabMajRUpMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia majora-spread-RUp.vmi");
                            if (LabMajRUpMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'Labia majora-spread-RUp'");
                                LabMajRUpMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            LabMinLMidMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/Labia minora-spread-LMid.vmi");
                            if (LabMinLMidMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'Labia minora-spread-LMid'");
                                LabMinLMidMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        }
                        catch { };

                        //ANUS SECTION

                        try
                        {
                            AWW_00_KegelMorph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources_Pak2.2:/Custom/Atom/Person/Morphs/female_genitalia/AWWalker/AWWalker_GEN_Morphs3.0/AWW_Kegel.vmi");
                            if (LabMinLMidMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'AWW_00_Kegel'");
                                AWW_00_KegelMorph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            AWW_Anus_SpreadGape02Morph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.9:/Custom/Atom/Person/Morphs/female_genitalia/AWWalker/AWWalker_ANUS_Morphs1.0/AWW_Anus_SpreadGape02.vmi");
                            if (LabMinLMidMorph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'AWW_Anus_SpreadGape02'");
                                AWW_Anus_SpreadGape02Morph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        } catch { };
                        try
                        {
                            AWWLabiaMinSwell01Morph = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources_Pak2.2:/Custom/Atom/Person/Morphs/female_genitalia/AWWalker/AWWalker_GEN_Morphs3.0/AWW-LabiaMin-Swell_01.vmi");
                            if (AWWLabiaMinSwell01Morph == null)
                            {
                                SuperController.LogError("Couldn't find morph 'AWW_00_Kegel'");
                                AWWLabiaMinSwell01Morph = morphUI.GetMorphByUid("Right Pinky Toe Bend");
                            }
                        }
                        catch { };
                    }
                }
                chest = containingAtom.GetStorableByID("chestControl") as FreeControllerV3;
                lKnee = containingAtom.GetStorableByID("lKneeControl") as FreeControllerV3;
                rKnee = containingAtom.GetStorableByID("rKneeControl") as FreeControllerV3;




            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }
        private void registerJSONParams() {
            OverallIntensity = new JSONStorableFloat("Intensity", 1f, 0f, 2f, false, true);
            OverallIntensity.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(OverallIntensity);

            AWW_Clitoris_HoodSizeRange = new JSONStorableFloat("AWW Hood Size", 0f, -1f, 1f, false, true);
            AWW_Clitoris_HoodSizeRange.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(AWW_Clitoris_HoodSizeRange);

            AWW_Clitoris_SizeRange = new JSONStorableFloat("AWW Clitoris Size", 0f, -1f, 1f, false, true);
            AWW_Clitoris_SizeRange.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(AWW_Clitoris_SizeRange);

            AWW_Clitoris_HoodBackRange = new JSONStorableFloat("Hood Back/Forward", 0f, -1f, 1f, false, true);
            AWW_Clitoris_HoodBackRange.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(AWW_Clitoris_HoodBackRange);

            AWW_Clitoris_Front_BackRange = new JSONStorableFloat("AWW Clitoris Front_Back", 0f, lmin => AWW_Clitoris_Front_BackRange.SetVal(Mathf.Max(AWW_Clitoris_Front_BackRange.val, lmin)), 0f, 1f, false, true);
            AWW_Clitoris_Front_BackRange.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(AWW_Clitoris_Front_BackRange);

            AWW_VagInternal_Size2ChangeMin = new JSONStorableFloat("AWW_VagInternal_Size Min", 0f, lmin => AWW_VagInternal_Size2ChangeMax.SetVal(Mathf.Max(AWW_VagInternal_Size2ChangeMax.val, lmin)), 0f, 1f, false, true);
            AWW_VagInternal_Size2ChangeMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(AWW_VagInternal_Size2ChangeMin);

            AWW_VagInternal_Size2ChangeMax = new JSONStorableFloat("AWW_VagInternal_Size Max", 1f, lmax => AWW_VagInternal_Size2ChangeMin.SetVal(Mathf.Min(AWW_VagInternal_Size2ChangeMin.val, lmax)), 0f, 1f, false, true);
            AWW_VagInternal_Size2ChangeMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(AWW_VagInternal_Size2ChangeMax);

            HoodModMorphChangeMin = new JSONStorableFloat("Labia HoodMod Min", 0.0f, lmin => HoodModMorphChangeMax.SetVal(Mathf.Max(HoodModMorphChangeMax.val, lmin)), -1f, 1f, false, true);
            HoodModMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(HoodModMorphChangeMin);

            HoodModMorphChangeMax = new JSONStorableFloat("Labia HoodMod Max", 0.87f, lmax => HoodModMorphChangeMin.SetVal(Mathf.Min(HoodModMorphChangeMin.val, lmax)), 0f, 1f, false, true);
            HoodModMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(HoodModMorphChangeMax);

            labiaMajoraMorphChangeMin = new JSONStorableFloat("Labia Majora Morph Min", -1.21f, lmin => labiaMajoraMorphChangeMax.SetVal(Mathf.Max(labiaMajoraMorphChangeMax.val, lmin)), -1f, 1f, false, true);
            labiaMajoraMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(labiaMajoraMorphChangeMin);

            labiaMajoraMorphChangeMax = new JSONStorableFloat("Labia Majora Morph Max", 2f, lmax => labiaMajoraMorphChangeMin.SetVal(Mathf.Min(labiaMajoraMorphChangeMin.val, lmax)), 0f, 1f, false, true);
            labiaMajoraMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(labiaMajoraMorphChangeMax);

            AWW_Majora_LeftUpperTopMorphChangeMin = new JSONStorableFloat("Left Top Tweak Morph Min", -0.4f, lmin => AWW_Majora_LeftUpperTopMorphChangeMax.SetVal(Mathf.Max(AWW_Majora_LeftUpperTopMorphChangeMax.val, lmin)), -1f, 1f, false, true);
            AWW_Majora_LeftUpperTopMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(AWW_Majora_LeftUpperTopMorphChangeMin);

            AWW_Majora_LeftUpperTopMorphChangeMax = new JSONStorableFloat("Left Top Tweak Morph Max", 0.9f, lmax => AWW_Majora_LeftUpperTopMorphChangeMin.SetVal(Mathf.Min(AWW_Majora_LeftUpperTopMorphChangeMin.val, lmax)), 0f, 1f, false, true);
            AWW_Majora_LeftUpperTopMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(AWW_Majora_LeftUpperTopMorphChangeMax);

            AWW_Majora_RightUpperTopMorphChangeMin = new JSONStorableFloat("Right Top Tweak Morph Min", -0.4f, lmin => AWW_Majora_RightUpperTopMorphChangeMax.SetVal(Mathf.Max(AWW_Majora_RightUpperTopMorphChangeMax.val, lmin)), -1f, 1f, false, true);
            AWW_Majora_RightUpperTopMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(AWW_Majora_RightUpperTopMorphChangeMin);

            AWW_Majora_RightUpperTopMorphChangeMax = new JSONStorableFloat("Right Top Tweak Morph Max", 0.9f, lmax => AWW_Majora_RightUpperTopMorphChangeMin.SetVal(Mathf.Min(AWW_Majora_RightUpperTopMorphChangeMin.val, lmax)), 0f, 1f, false, true);
            AWW_Majora_RightUpperTopMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(AWW_Majora_RightUpperTopMorphChangeMax);

            LabMajLUpMorphChangeMin = new JSONStorableFloat("Labia LabMajLUp Min", -0.45f, lmin => LabMajLUpMorphChangeMax.SetVal(Mathf.Max(LabMajLUpMorphChangeMax.val, lmin)), -1f, 1f, false, true);
            LabMajLUpMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMajLUpMorphChangeMin);

            LabMajLUpMorphChangeMax = new JSONStorableFloat("Labia LabMajLUp Max", 0.35f, lmax => LabMajLUpMorphChangeMin.SetVal(Mathf.Min(LabMajLUpMorphChangeMin.val, lmax)), 0f, 1f, false, true);
            LabMajLUpMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMajLUpMorphChangeMax);

            LabMajRUpMorphChangeMin = new JSONStorableFloat("Labia LabMajRUp Min", -0.45f, lmin => LabMajRUpMorphChangeMax.SetVal(Mathf.Max(LabMajRUpMorphChangeMax.val, lmin)), -1f, 1f, false, true);
            LabMajRUpMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMajRUpMorphChangeMin);

            LabMajRUpMorphChangeMax = new JSONStorableFloat("Labia LabMajRUp Max", 0.35f, lmax => LabMajRUpMorphChangeMin.SetVal(Mathf.Min(LabMajRUpMorphChangeMin.val, lmax)), 0f, 1f, false, true);
            LabMajRUpMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMajRUpMorphChangeMax);

            LabMajLMidMorphChangeMin = new JSONStorableFloat("Labia LabMajLMid Min", 0.25f, lmin => LabMajLMidMorphChangeMax.SetVal(Mathf.Max(LabMajLMidMorphChangeMax.val, lmin)), -1f, 1f, false, true);
            LabMajLMidMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMajLMidMorphChangeMin);

            LabMajLMidMorphChangeMax = new JSONStorableFloat("Labia LabMajLMid Max", 0.4f, lmax => LabMajLMidMorphChangeMin.SetVal(Mathf.Min(LabMajLMidMorphChangeMin.val, lmax)), 0f, 1f, false, true);
            LabMajLMidMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMajLMidMorphChangeMax);

            LabMajRMidMorphChangeMin = new JSONStorableFloat("Labia LabMajRMid Min", 0.25f, lmin => LabMajRMidMorphChangeMax.SetVal(Mathf.Max(LabMajRMidMorphChangeMax.val, lmin)), -1f, 1f, false, true);
            LabMajRMidMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMajRMidMorphChangeMin);

            LabMajRMidMorphChangeMax = new JSONStorableFloat("Labia LabMajRMid Max", 0.4f, lmax => LabMajRMidMorphChangeMin.SetVal(Mathf.Min(LabMajRMidMorphChangeMin.val, lmax)), 0f, 1f, false, true);
            LabMajRMidMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMajRMidMorphChangeMax);

            LabMajLLowMorphChangeMin = new JSONStorableFloat("Labia LabMajLLow Min", 0.25f, lmin => LabMajLLowMorphChangeMax.SetVal(Mathf.Max(LabMajLLowMorphChangeMax.val, lmin)), -1f, 1f, false, true);
            LabMajLLowMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMajLLowMorphChangeMin);

            LabMajLLowMorphChangeMax = new JSONStorableFloat("Labia LabMajLLow Max", 0.65f, lmax => LabMajLLowMorphChangeMin.SetVal(Mathf.Min(LabMajLLowMorphChangeMin.val, lmax)), 0f, 1f, false, true);
            LabMajLLowMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMajLLowMorphChangeMax);

            LabMajRLowMorphChangeMin = new JSONStorableFloat("Labia LabMajRLow Min", 0.25f, lmin => LabMajRLowMorphChangeMax.SetVal(Mathf.Max(LabMajRLowMorphChangeMax.val, lmin)), -1f, 1f, false, true);
            LabMajRLowMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMajRLowMorphChangeMin);

            LabMajRLowMorphChangeMax = new JSONStorableFloat("Labia LabMajRLow Max", 0.65f, lmax => LabMajRLowMorphChangeMin.SetVal(Mathf.Min(LabMajRLowMorphChangeMin.val, lmax)), 0f, 1f, false, true);
            LabMajRLowMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMajRLowMorphChangeMax);

            //Minora 

            labiaMinoraMorphChangeMin = new JSONStorableFloat("Labia Minora Morph Min", -0.7f, lmin => labiaMinoraMorphChangeMax.SetVal(Mathf.Max(labiaMinoraMorphChangeMax.val, lmin)), -1f, 1f, false, true);
            labiaMinoraMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(labiaMinoraMorphChangeMin);

            labiaMinoraMorphChangeMax = new JSONStorableFloat("Labia Minora Morph Max", 1f, lmax => labiaMinoraMorphChangeMin.SetVal(Mathf.Min(labiaMinoraMorphChangeMin.val, lmax)), 0f, 1f, false, true);
            labiaMinoraMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(labiaMinoraMorphChangeMax);

            LabMinLUpMorphChangeMin = new JSONStorableFloat("Labia LabMinLUp Min", -0.25f, lmin => LabMinLUpMorphChangeMax.SetVal(Mathf.Max(LabMinLUpMorphChangeMax.val, lmin)), -1f, 1f, false, true);
            LabMinLUpMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMinLUpMorphChangeMin);

            LabMinLUpMorphChangeMax = new JSONStorableFloat("Labia LabMinLUp Max", 0.8f, lmax => LabMinLUpMorphChangeMin.SetVal(Mathf.Min(LabMinLUpMorphChangeMin.val, lmax)), 0f, 1f, false, true);
            LabMinLUpMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMinLUpMorphChangeMax);


            LabMinRUpMorphChangeMin = new JSONStorableFloat("Labia LabMinRUp Min", -0.25f, lmin => LabMinRUpMorphChangeMax.SetVal(Mathf.Max(LabMinRUpMorphChangeMax.val, lmin)), -1f, 1f, false, true);
            LabMinRUpMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMinRUpMorphChangeMin);

            LabMinRUpMorphChangeMax = new JSONStorableFloat("Labia LabMinRUp Max", 0.8f, lmax => LabMinRUpMorphChangeMin.SetVal(Mathf.Min(LabMinRUpMorphChangeMin.val, lmax)), 0f, 1f, false, true);
            LabMinRUpMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMinRUpMorphChangeMax);

            LabMinLMidMorphChangeMin = new JSONStorableFloat("Labia LabMinLMid Min", -0.1f, lmin => LabMinLMidMorphChangeMax.SetVal(Mathf.Max(LabMinLMidMorphChangeMax.val, lmin)), -1f, 1f, false, true);
            LabMinLMidMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMinLMidMorphChangeMin);

            LabMinLMidMorphChangeMax = new JSONStorableFloat("Labia LabMinLMid Max", 0.50f, lmax => LabMinLMidMorphChangeMin.SetVal(Mathf.Min(LabMinLMidMorphChangeMin.val, lmax)), 0f, 1f, false, true);
            LabMinLMidMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMinLMidMorphChangeMax);

            LabMinRMidMorphChangeMin = new JSONStorableFloat("Labia LabMinRMid Min", -0.1f, lmin => LabMinRMidMorphChangeMax.SetVal(Mathf.Max(LabMinRMidMorphChangeMax.val, lmin)), -1f, 1f, false, true);
            LabMinRMidMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMinRMidMorphChangeMin);

            LabMinRMidMorphChangeMax = new JSONStorableFloat("Labia LabMinRMid Max", 0.50f, lmax => LabMinRMidMorphChangeMin.SetVal(Mathf.Min(LabMinRMidMorphChangeMin.val, lmax)), 0f, 1f, false, true);
            LabMinRMidMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMinRMidMorphChangeMax);


            LabMinLLowMorphChangeMin = new JSONStorableFloat("Labia LabMinLLow Min", 0f, lmin => LabMinLLowMorphChangeMax.SetVal(Mathf.Max(LabMinLLowMorphChangeMax.val, lmin)), -1f, 1f, false, true);
            LabMinLLowMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMinLLowMorphChangeMin);

            LabMinRLowMorphChangeMax = new JSONStorableFloat("Labia LabMinRLow Max", 0.75f, lmax => LabMinRLowMorphChangeMin.SetVal(Mathf.Min(LabMinRLowMorphChangeMin.val, lmax)), 0f, 1f, false, true);
            LabMinRLowMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMinRLowMorphChangeMax);

            LabMinRLowMorphChangeMin = new JSONStorableFloat("Labia LabMinRLow Min", 0f, lmin => LabMinRLowMorphChangeMax.SetVal(Mathf.Max(LabMinRLowMorphChangeMax.val, lmin)), -1f, 1f, false, true);
            LabMinRLowMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMinRLowMorphChangeMin);

            LabMinLLowMorphChangeMax = new JSONStorableFloat("Labia LabMinLLow Max", 0.75f, lmax => LabMinLLowMorphChangeMin.SetVal(Mathf.Min(LabMinLLowMorphChangeMin.val, lmax)), 0f, 1f, false, true);
            LabMinLLowMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(LabMinLLowMorphChangeMax);

            //ANUS MORPHS
            //AWW_00_Kegel
            AWW_00_KegelMin = new JSONStorableFloat("Cinch Ass Min", 0f, lmin => AWW_00_KegelMax.SetVal(Mathf.Max(AWW_00_KegelMax.val, lmin)), 0f, 1f, false, true);
            AWW_00_KegelMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(AWW_00_KegelMin);

            AWW_00_KegelMax = new JSONStorableFloat("Cinch Ass Max", 1f, lmax => AWW_00_KegelMin.SetVal(Mathf.Min(AWW_00_KegelMin.val, lmax)), 0f, 1f, false, true);
            AWW_00_KegelMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(AWW_00_KegelMax);

            AWW_Anus_SpreadGape02Min = new JSONStorableFloat("Anus_SpreadGape Min", 0.0f, lmin => AWW_Anus_SpreadGape02Max.SetVal(Mathf.Max(AWW_Anus_SpreadGape02Max.val, lmin)), -1f, 1f, false, true);
            AWW_Anus_SpreadGape02Min.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(AWW_Anus_SpreadGape02Min);

            AWW_Anus_SpreadGape02Max = new JSONStorableFloat("Anus_SpreadGape Max", 0.1f, lmax => AWW_Anus_SpreadGape02Min.SetVal(Mathf.Min(AWW_Anus_SpreadGape02Min.val, lmax)), 0f, 1f, false, true);
            AWW_Anus_SpreadGape02Max.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(AWW_Anus_SpreadGape02Max);

            AWW_GenLabiaMajoraClosedAndSmoothMorphMin = new JSONStorableFloat("Majora Closed And Smooth Min", -1f, lmin => AWW_GenLabiaMajoraClosedAndSmoothMorphMax.SetVal(Mathf.Max(AWW_GenLabiaMajoraClosedAndSmoothMorphMax.val, lmin)), -1f, 0f, false, true);
            AWW_GenLabiaMajoraClosedAndSmoothMorphMin.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(AWW_GenLabiaMajoraClosedAndSmoothMorphMin);

            AWW_GenLabiaMajoraClosedAndSmoothMorphMax = new JSONStorableFloat("Majora Closed And Smooth Max", 1f, lmax => AWW_GenLabiaMajoraClosedAndSmoothMorphMin.SetVal(Mathf.Min(AWW_GenLabiaMajoraClosedAndSmoothMorphMin.val, lmax)), 0f, 1f, false, true);
            AWW_GenLabiaMajoraClosedAndSmoothMorphMax.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(AWW_GenLabiaMajoraClosedAndSmoothMorphMax);

            CurveEnabled = new JSONStorableBool("Apply Curve", true);
            sIsEnabled = new JSONStorableBool("Multi Pass Enabled", true);
            RegisterBool(CurveEnabled);
            RegisterBool(sIsEnabled);

            StaticMinApplication = new JSONStorableBool("Use Min Value Only (Static Morphs)", false);
            RegisterBool(StaticMinApplication);

            StaticMaxApplication = new JSONStorableBool("Use Max Value Only (Static Morphs)", false);
            RegisterBool(StaticMaxApplication);

            AWW_PuffyMajora_1Range = new JSONStorableFloat("AWW Puffy Pussy", 0f, -1f, 1f, false, true);
            AWW_PuffyMajora_1Range.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(AWW_PuffyMajora_1Range);

            AWWLabiaMinSwell01Range = new JSONStorableFloat("AWW Swollen Minora", 0f, 0f, 1f, false, true);
            AWWLabiaMinSwell01Range.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(AWWLabiaMinSwell01Range);

        }
        public void buildUI()
        {
            //Create UI

            CreateMainUI();
            StaticMorphUI();
            CenteredMorphUI();
            MinoraMorphUI();
            DebugSectionUI();
            TBDextraUI();

        }
        public void CreateMainUI() {
            UIDynamicToggle tglIsEnabled = CreateToggle(sIsEnabled, leftSide);
            string txtTitle = "AWWalker's Genital Multi-Pass\nKudos to: VeeRifter & MacGruber \nVersion: " + gmpversion + " " + isDev;
            JSONStorableString strTitle = new JSONStorableString("Title", txtTitle);
            UIDynamicTextField textfieldtitl = CreateTextField(strTitle, rightSide);
            Destroy(textfieldtitl);

            var savePresetUI = CreateButton("Save Preset", rightSide);
            savePresetUI.button.onClick.AddListener(() =>
            {
                FileManagerSecure.CreateDirectory(_gmpSavePath);
                var fileBrowserUI = SuperController.singleton.fileBrowserUI;
                fileBrowserUI.SetTitle("Save colliders preset");
                fileBrowserUI.showFiles = true;
                fileBrowserUI.fileRemovePrefix = null;
                fileBrowserUI.hideExtension = true;
                fileBrowserUI.keepOpen = false;
                fileBrowserUI.fileFormat = _saveExt;
                fileBrowserUI.defaultPath = _gmpSavePath;
                fileBrowserUI.showDirs = true;
                fileBrowserUI.SetTextEntry(true);
                fileBrowserUI.Show(saveUI);
                fileBrowserUI.fileEntryField.text = (int)(DateTime.UtcNow - new DateTime(1970, 1, 1)).TotalSeconds + "." + _saveExt;
                fileBrowserUI.ActivateFileNameField();
            });
            var loadPresetUI = CreateButton("Load Preset", true);
            loadPresetUI.button.onClick.AddListener(() =>
            {
                FileManagerSecure.CreateDirectory(_gmpLoadPath);
                var shortcuts = FileManagerSecure.GetShortCutsForDirectory(_gmpLoadPath);
                SuperController.singleton.GetMediaPathDialog(loadUI, _saveExt, _gmpLoadPath, false, true, false, null, false, shortcuts);
            });
            textfieldtitl.height = 120;
            textfieldtitl.textColor = UnityEngine.Color.blue;
            textfieldtitl.backgroundColor = cClear;
            //textfielddesc.backgroundImage 
            UIDynamicButton btnDefaults = CreateButton("Load Defaults", true);
            btnDefaults.button.onClick.AddListener(RestoreAllFromDefaults);
            btnDefaults.buttonText.fontSize = 28;
            var btnZeroed = CreateButton("Zero All", true);
            btnZeroed.button.onClick.AddListener(() =>
            {
                zeroAllSettings();
            });
            createLeftSPACER(50);
            createStdSLIDER(OverallIntensity, Color.black, 45, false);
            UIDynamicToggle tglCurveEnabled = CreateToggle(CurveEnabled, false);
        }
        public void StaticMorphUI()
        {
            createLeftSPACER(50);
            createTitle("Static Morphs", cBlue, "These morphs aren't affected by opening and closing position.", cBlack);
            int statSldfontSize = 23;

            UIDynamicSlider sldClitHoodBack = CreateSlider(AWW_Clitoris_HoodBackRange, false);
            sldClitHoodBack.labelText.fontSize = statSldfontSize;

            UIDynamicSlider sldClitHoodSize = CreateSlider(AWW_Clitoris_HoodSizeRange, false);
            sldClitHoodSize.labelText.fontSize = statSldfontSize;

            UIDynamicSlider sldPuffyMajor = CreateSlider(AWW_PuffyMajora_1Range, false);
            sldPuffyMajor.labelText.fontSize = statSldfontSize;

            UIDynamicSlider sldClitHoodFB = CreateSlider(AWW_Clitoris_Front_BackRange, true);
            sldClitHoodFB.labelText.fontSize = statSldfontSize;

            UIDynamicSlider sldClitSize = CreateSlider(AWW_Clitoris_SizeRange, true);
            sldClitSize.labelText.fontSize = statSldfontSize;

            UIDynamicSlider sldAWWSwellMinoroa = CreateSlider(AWWLabiaMinSwell01Range, true);
            sldAWWSwellMinoroa.labelText.fontSize = statSldfontSize;
        }
        public void CenteredMorphUI()
        {

            createTitle("Centered Morphs", cBlue, "Morphs that affect center tid bits", cBlack);

            createMorphSLIDER(HoodModMorphChangeMin, cBlue, false);
            createMorphSLIDER(HoodModMorphChangeMax, cBlue, true);

            createMorphSLIDER(AWW_VagInternal_Size2ChangeMin, cBlue, false);
            createMorphSLIDER(AWW_VagInternal_Size2ChangeMax, cBlue, true);

            createMorphSLIDER(AWW_00_KegelMin, cBlue, false);
            createMorphSLIDER(AWW_00_KegelMax, cBlue, true);

            createMorphSLIDER(AWW_Anus_SpreadGape02Min, cBlue, false);
            createMorphSLIDER(AWW_Anus_SpreadGape02Max, cBlue, true);

            createMorphSLIDER(AWW_GenLabiaMajoraClosedAndSmoothMorphMin, cBlue, false);
            createMorphSLIDER(AWW_GenLabiaMajoraClosedAndSmoothMorphMax, cBlue, true);



        }
        public void MajoraMorphUI()
        {
            createTitle("Labia Majora", cBlack, "Yummy", cBlack);
            createMorphSLIDER(labiaMajoraMorphChangeMin, cBlue, false);
            createMorphSLIDER(labiaMajoraMorphChangeMax, cBlue, true);
            createMorphSLIDER(AWW_Majora_RightUpperTopMorphChangeMin, cBlue, false);
            createMorphSLIDER(AWW_Majora_RightUpperTopMorphChangeMax, cBlue, true);
            createMorphSLIDER(AWW_Majora_LeftUpperTopMorphChangeMin, cBlue, false);
            createMorphSLIDER(AWW_Majora_LeftUpperTopMorphChangeMax, cBlue, true);
            createMorphSLIDER(LabMajRUpMorphChangeMin, cBlue, false);
            createMorphSLIDER(LabMajRUpMorphChangeMax, cBlue, true);
            createMorphSLIDER(LabMajLUpMorphChangeMin, cBlue, false);
            createMorphSLIDER(LabMajLUpMorphChangeMax, cBlue, true);
            createMorphSLIDER(LabMajRMidMorphChangeMin, cBlue, false);
            createMorphSLIDER(LabMajRMidMorphChangeMax, cBlue, true);
            createMorphSLIDER(LabMajLMidMorphChangeMin, cBlue, false);
            createMorphSLIDER(LabMajLMidMorphChangeMax, cBlue, true);
            createMorphSLIDER(LabMajRLowMorphChangeMin, cBlue, false);
            createMorphSLIDER(LabMajRLowMorphChangeMax, cBlue, true);
            createMorphSLIDER(LabMajLLowMorphChangeMin, cBlue, false);
            createMorphSLIDER(LabMajLLowMorphChangeMax, cBlue, true);
        }
        public void MinoraMorphUI()
        {
            createTitle("Labia Minora", cBlack, "Sweet", cBlack);
            createMorphSLIDER(labiaMinoraMorphChangeMin, cBlue, false);
            createMorphSLIDER(labiaMinoraMorphChangeMax, cBlue, true);
            createMorphSLIDER(LabMinRUpMorphChangeMin, cBlue, false);
            createMorphSLIDER(LabMinRUpMorphChangeMax, cBlue, true);
            createMorphSLIDER(LabMinLUpMorphChangeMin, cBlue, false);
            createMorphSLIDER(LabMinLUpMorphChangeMax, cBlue, true);
            createMorphSLIDER(LabMinRMidMorphChangeMin, cBlue, false);
            createMorphSLIDER(LabMinRMidMorphChangeMax, cBlue, true);
            createMorphSLIDER(LabMinLMidMorphChangeMin, cBlue, false);
            createMorphSLIDER(LabMinLMidMorphChangeMax, cBlue, true);
            createMorphSLIDER(LabMinRLowMorphChangeMin, cBlue, false);
            createMorphSLIDER(LabMinRLowMorphChangeMax, cBlue, true);
            createMorphSLIDER(LabMinLLowMorphChangeMin, cBlue, false);
            createMorphSLIDER(LabMinLLowMorphChangeMax, cBlue, true);
        }
        public void DebugSectionUI()
        {
        createTitle("DEBUG", cRed, "Use the following to view max and miniumum positions", cBlack);
        createTitle("", cRed, "Can also be used to lock morphs in to a position, rather then using spread controller.", cBlack);
        createTitle("", cRed, "Setting not included in save.", cRed);
        UIDynamicToggle tglStaticMinOnly = CreateToggle(StaticMinApplication, leftSide);
        UIDynamicToggle tglStaticMaxOnly = CreateToggle(StaticMaxApplication, rightSide);
        }
        public void TBDextraUI()
        {
            createTitle("TBD::", cBlue, "Add Custom Morph Section here... WIP... Coming Soon.", cBlue);

            if (DebugBuild)
            {
                var morphControlUI = ((DAZCharacterSelector)containingAtom.GetStorableByID("geometry")).morphsControlUI;

                var morphNames = morphControlUI.GetMorphDisplayNames().OrderBy(n => n).ToList();
                var addMorphStorable = new JSONStorableStringChooser("Morph", morphNames, "", "Morph");
                var popup = CreateFilterablePopup(addMorphStorable);
                var add = CreateButton("Add", rightSide: false);
                add.buttonColor = Color.green;
            }
        }
        public void Update()
        {
            if (sIsEnabled.val)
            {


                if (StaticMinApplication.val)
                {
                    ApplyMinValuesToMorphs();
                }
                else if (StaticMaxApplication.val)
                {
                    ApplyMaxValuesToMorphs();
                }
                else
                {
                    ApplySpreadValuesToMorphs();
                };



            }
        }
        private void saveUI(string path)
        {

            
            SuperController.singleton.fileBrowserUI.fileFormat = "json";
            if (string.IsNullOrEmpty(path)) return;
            if (!path.ToLower().EndsWith($".{_saveExt}")) path += $"_MultiPass.{_saveExt}";
            //if (!path.ToLower().EndsWith($".{_saveExt}")) path += $".{_saveExt}";
            

            
            JSONClass jc = new JSONClass();
            JSONClass info = new JSONClass();
            JSONClass userData = new JSONClass();
            info["AWWalker"] = "A White Walker";
            info["Format"] = "AWWalker.MultiPass";
            info["Version"].AsInt = GMP_VERSION;
            info["PushlishDate"] = PUBLISH_DATE;

            string creatorName = UserPreferences.singleton.creatorName;
            if (string.IsNullOrEmpty(creatorName))
                creatorName = "Unknown";
            userData["Author"] = creatorName;  //Saves you as author :)
            string datetime = DateTime.UtcNow.ToString();
            userData["SaveTimeStamp"] = datetime;

            jc["Info"] = info;
            jc["UserData"] = userData;
            jc["sIsEnabled"].AsBool = sIsEnabled.val;
            jc["CurveEnabled"].AsBool = CurveEnabled.val;
            jc["OverallIntensity"].AsFloat = OverallIntensity.val;
            jc["LabMinRUpMorphChangeMin"].AsFloat = LabMinRUpMorphChangeMin.val;
            jc["LabMinRUpMorphChangeMax"].AsFloat = LabMinRUpMorphChangeMax.val;
            jc["LabMinRMidMorphChangeMin"].AsFloat = LabMinRMidMorphChangeMin.val;
            jc["LabMinRMidMorphChangeMax"].AsFloat = LabMinRMidMorphChangeMax.val;
            jc["LabMinRLowMorphChangeMin"].AsFloat = LabMinRLowMorphChangeMin.val;
            jc["LabMinRLowMorphChangeMax"].AsFloat = LabMinRLowMorphChangeMax.val;
            jc["LabMinLUpMorphChangeMin"].AsFloat = LabMinLUpMorphChangeMin.val;
            jc["LabMinLUpMorphChangeMax"].AsFloat = LabMinLUpMorphChangeMax.val;
            jc["LabMinLMidMorphChangeMin"].AsFloat = LabMinLMidMorphChangeMin.val;
            jc["LabMinLMidMorphChangeMax"].AsFloat = LabMinLMidMorphChangeMax.val;
            jc["LabMinLLowMorphChangeMin"].AsFloat = LabMinLLowMorphChangeMin.val;
            jc["LabMinLLowMorphChangeMax"].AsFloat = LabMinLLowMorphChangeMax.val;
            jc["LabMajRUpMorphChangeMin"].AsFloat = LabMajRUpMorphChangeMin.val;
            jc["LabMajRUpMorphChangeMax"].AsFloat = LabMajRUpMorphChangeMax.val;
            jc["LabMajRMidMorphChangeMin"].AsFloat = LabMajRMidMorphChangeMin.val;
            jc["LabMajRMidMorphChangeMax"].AsFloat = LabMajRMidMorphChangeMax.val;
            jc["LabMajRLowMorphChangeMin"].AsFloat = LabMajRLowMorphChangeMin.val;
            jc["LabMajRLowMorphChangeMax"].AsFloat = LabMajRLowMorphChangeMax.val;
            jc["LabMajLUpMorphChangeMin"].AsFloat = LabMajLUpMorphChangeMin.val;
            jc["LabMajLUpMorphChangeMax"].AsFloat = LabMajLUpMorphChangeMax.val;
            jc["LabMajLMidMorphChangeMin"].AsFloat = LabMajLMidMorphChangeMin.val;
            jc["LabMajLMidMorphChangeMax"].AsFloat = LabMajLMidMorphChangeMax.val;
            jc["LabMajLLowMorphChangeMin"].AsFloat = LabMajLLowMorphChangeMin.val;
            jc["LabMajLLowMorphChangeMax"].AsFloat = LabMajLLowMorphChangeMax.val;
            jc["labiaMinoraMorphChangeMin"].AsFloat = labiaMinoraMorphChangeMin.val;
            jc["labiaMinoraMorphChangeMax"].AsFloat = labiaMinoraMorphChangeMax.val;
            jc["labiaMajoraMorphChangeMin"].AsFloat = labiaMajoraMorphChangeMin.val;
            jc["labiaMajoraMorphChangeMax"].AsFloat = labiaMajoraMorphChangeMax.val;
            jc["HoodModMorphChangeMin"].AsFloat = HoodModMorphChangeMin.val;
            jc["HoodModMorphChangeMax"].AsFloat = HoodModMorphChangeMax.val;
            jc["AWW_VagInternal_Size2ChangeMin"].AsFloat = AWW_VagInternal_Size2ChangeMin.val;
            jc["AWW_VagInternal_Size2ChangeMax"].AsFloat = AWW_VagInternal_Size2ChangeMax.val;
            jc["AWW_PuffyMajora_1Range"].AsFloat = AWW_PuffyMajora_1Range.val;
            jc["AWW_Majora_RightUpperTopMorphChangeMin"].AsFloat = AWW_Majora_RightUpperTopMorphChangeMin.val;
            jc["AWW_Majora_RightUpperTopMorphChangeMax"].AsFloat = AWW_Majora_RightUpperTopMorphChangeMax.val;
            jc["AWW_Majora_LeftUpperTopMorphChangeMin"].AsFloat = AWW_Majora_LeftUpperTopMorphChangeMin.val;
            jc["AWW_Majora_LeftUpperTopMorphChangeMax"].AsFloat = AWW_Majora_LeftUpperTopMorphChangeMax.val;
            jc["AWW_GenLabiaMajoraClosedAndSmoothMorphMin"].AsFloat = AWW_GenLabiaMajoraClosedAndSmoothMorphMin.val;
            jc["AWW_GenLabiaMajoraClosedAndSmoothMorphMax"].AsFloat = AWW_GenLabiaMajoraClosedAndSmoothMorphMax.val;
            jc["AWW_Clitoris_SizeRange"].AsFloat = AWW_Clitoris_SizeRange.val;
            jc["AWW_Clitoris_SizeMax"].AsFloat = AWW_Clitoris_SizeRange.val;
            jc["AWW_Clitoris_HoodSizeRange"].AsFloat = AWW_Clitoris_HoodSizeRange.val;
            jc["AWW_Clitoris_HoodSizeMax"].AsFloat = AWW_Clitoris_HoodSizeRange.val;
            jc["AWW_Clitoris_HoodBackRange"].AsFloat = AWW_Clitoris_HoodBackRange.val;
            jc["AWW_Clitoris_HoodBackMax"].AsFloat = AWW_Clitoris_HoodBackRange.val;
            jc["AWW_Clitoris_Front_BackRange"].AsFloat = AWW_Clitoris_Front_BackRange.val;
            jc["AWW_Clitoris_Front_BackMax"].AsFloat = AWW_Clitoris_Front_BackRange.val;
            jc["AWW_Anus_SpreadGape02Min"].AsFloat = AWW_Anus_SpreadGape02Min.val;
            jc["AWW_Anus_SpreadGape02Max"].AsFloat = AWW_Anus_SpreadGape02Max.val;
            jc["AWW_00_KegelMin"].AsFloat = AWW_00_KegelMin.val;
            jc["AWW_00_KegelMax"].AsFloat = AWW_00_KegelMax.val;
            jc["AWWLabiaMinSwell01Range"].AsFloat = AWWLabiaMinSwell01Range.val;

            SaveJSON(jc, path);

        }
        private void loadUI(string path)
        {

            if (string.IsNullOrEmpty(path))
                return;
            
            JSONClass jc = LoadJSON(path).AsObject;
            JSONClass info = new JSONClass();
            info = (JSONClass)jc["Info"];

            SuperController.LogMessage("Loading of " + path + "`n" + info["Format"].Value);

            if (info["Format"].Value == "AWWalker.MultiPass")
            {
                try
                {

                    //try { sIsEnabled.val = jc["sIsEnabled"].AsBool; } catch { SuperController.LogError("Couldn't apply settings to :sIsEnabled"); }  // Don't Load Enabled Disabled Bool /// Stupid Me
                    try { CurveEnabled.val = jc["CurveEnabled"].AsBool; } catch { SuperController.LogError("Couldn't apply settings to :CurveEnabled"); }
                    try { OverallIntensity.val = jc["OverallIntensity"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :OverallIntensity"); }
                    try { LabMinRUpMorphChangeMin.val = jc["LabMinRUpMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinRUpMorphChangeMin"); }
                    try { LabMinRUpMorphChangeMax.val = jc["LabMinRUpMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinRUpMorphChangeMax"); }
                    try { LabMinRMidMorphChangeMin.val = jc["LabMinRMidMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinRMidMorphChangeMin"); }
                    try { LabMinRMidMorphChangeMax.val = jc["LabMinRMidMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinRMidMorphChangeMax"); }
                    try { LabMinRLowMorphChangeMin.val = jc["LabMinRLowMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinRLowMorphChangeMin"); }
                    try { LabMinRLowMorphChangeMax.val = jc["LabMinRLowMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinRLowMorphChangeMax"); }
                    try { LabMinLUpMorphChangeMin.val = jc["LabMinLUpMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinLUpMorphChangeMin"); }
                    try { LabMinLUpMorphChangeMax.val = jc["LabMinLUpMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinLUpMorphChangeMax"); }
                    try { LabMinLMidMorphChangeMin.val = jc["LabMinLMidMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinLMidMorphChangeMin"); }
                    try { LabMinLMidMorphChangeMax.val = jc["LabMinLMidMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinLMidMorphChangeMax"); }
                    try { LabMinLLowMorphChangeMin.val = jc["LabMinLLowMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinLLowMorphChangeMin"); }
                    try { LabMinLLowMorphChangeMax.val = jc["LabMinLLowMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMinLLowMorphChangeMax"); }
                    try { LabMajRUpMorphChangeMin.val = jc["LabMajRUpMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajRUpMorphChangeMin"); }
                    try { LabMajRUpMorphChangeMax.val = jc["LabMajRUpMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajRUpMorphChangeMax"); }
                    try { LabMajRMidMorphChangeMin.val = jc["LabMajRMidMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajRMidMorphChangeMin"); }
                    try { LabMajRMidMorphChangeMax.val = jc["LabMajRMidMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajRMidMorphChangeMax"); }
                    try { LabMajRLowMorphChangeMin.val = jc["LabMajRLowMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajRLowMorphChangeMin"); }
                    try { LabMajRLowMorphChangeMax.val = jc["LabMajRLowMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajRLowMorphChangeMax"); }
                    try { LabMajLUpMorphChangeMin.val = jc["LabMajLUpMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajLUpMorphChangeMin"); }
                    try { LabMajLUpMorphChangeMax.val = jc["LabMajLUpMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajLUpMorphChangeMax"); }
                    try { LabMajLMidMorphChangeMin.val = jc["LabMajLMidMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajLMidMorphChangeMin"); }
                    try { LabMajLMidMorphChangeMax.val = jc["LabMajLMidMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajLMidMorphChangeMax"); }
                    try { LabMajLLowMorphChangeMin.val = jc["LabMajLLowMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajLLowMorphChangeMin"); }
                    try { LabMajLLowMorphChangeMax.val = jc["LabMajLLowMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :LabMajLLowMorphChangeMax"); }
                    try { labiaMinoraMorphChangeMin.val = jc["labiaMinoraMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :labiaMinoraMorphChangeMin"); }
                    try { labiaMinoraMorphChangeMax.val = jc["labiaMinoraMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :labiaMinoraMorphChangeMax"); }
                    try { labiaMajoraMorphChangeMin.val = jc["labiaMajoraMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :labiaMajoraMorphChangeMin"); }
                    try { labiaMajoraMorphChangeMax.val = jc["labiaMajoraMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :labiaMajoraMorphChangeMax"); }
                    try { HoodModMorphChangeMin.val = jc["HoodModMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :HoodModMorphChangeMin"); }
                    try { HoodModMorphChangeMax.val = jc["HoodModMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :HoodModMorphChangeMax"); }
                    try { AWW_VagInternal_Size2ChangeMin.val = jc["AWW_VagInternal_Size2ChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_VagInternal_Size2ChangeMin"); }
                    try { AWW_VagInternal_Size2ChangeMax.val = jc["AWW_VagInternal_Size2ChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_VagInternal_Size2ChangeMax"); }
                    try { AWW_PuffyMajora_1Range.val = jc["AWW_PuffyMajora_1Range"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_PuffyMajora_1Range"); }
                    try { AWW_Majora_RightUpperTopMorphChangeMin.val = jc["AWW_Majora_RightUpperTopMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Majora_RightUpperTopMorphChangeMin"); }
                    try { AWW_Majora_RightUpperTopMorphChangeMax.val = jc["AWW_Majora_RightUpperTopMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Majora_RightUpperTopMorphChangeMax"); }
                    try { AWW_Majora_LeftUpperTopMorphChangeMin.val = jc["AWW_Majora_LeftUpperTopMorphChangeMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Majora_LeftUpperTopMorphChangeMin"); }
                    try { AWW_Majora_LeftUpperTopMorphChangeMax.val = jc["AWW_Majora_LeftUpperTopMorphChangeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Majora_LeftUpperTopMorphChangeMax"); }
                    try { AWW_GenLabiaMajoraClosedAndSmoothMorphMin.val = jc["AWW_GenLabiaMajoraClosedAndSmoothMorphMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_GenLabiaMajoraClosedAndSmoothMorphMin"); }
                    try { AWW_GenLabiaMajoraClosedAndSmoothMorphMax.val = jc["AWW_GenLabiaMajoraClosedAndSmoothMorphMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_GenLabiaMajoraClosedAndSmoothMorphMax"); }
                    try { AWW_Clitoris_SizeRange.val = jc["AWW_Clitoris_SizeRange"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Clitoris_SizeRange"); }
                    try { AWW_Clitoris_SizeRange.val = jc["AWW_Clitoris_SizeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Clitoris_SizeMax"); }
                    try { AWW_Clitoris_HoodSizeRange.val = jc["AWW_Clitoris_HoodSizeRange"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Clitoris_HoodSizeRange"); }
                    try { AWW_Clitoris_HoodSizeRange.val = jc["AWW_Clitoris_HoodSizeMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Clitoris_HoodSizeMax"); }
                    try { AWW_Clitoris_HoodBackRange.val = jc["AWW_Clitoris_HoodBackRange"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Clitoris_HoodBackRange"); }
                    try { AWW_Clitoris_HoodBackRange.val = jc["AWW_Clitoris_HoodBackMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Clitoris_HoodBackMax"); }
                    try { AWW_Clitoris_Front_BackRange.val = jc["AWW_Clitoris_Front_BackRange"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Clitoris_Front_BackRange"); }
                    try { AWW_Clitoris_Front_BackRange.val = jc["AWW_Clitoris_Front_BackMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Clitoris_Front_BackMax"); }
                    try { AWW_Anus_SpreadGape02Min.val = jc["AWW_Anus_SpreadGape02Min"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Anus_SpreadGape02Min"); }
                    try { AWW_Anus_SpreadGape02Max.val = jc["AWW_Anus_SpreadGape02Max"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_Anus_SpreadGape02Max"); }
                    try { AWW_00_KegelMin.val = jc["AWW_00_KegelMin"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_00_KegelMin"); }
                    try { AWW_00_KegelMax.val = jc["AWW_00_KegelMax"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWW_00_KegelMax"); }
                    try { AWWLabiaMinSwell01Range.val = jc["AWWLabiaMinSwell01Range"].AsFloat; } catch { SuperController.LogError("Couldn't apply settings to :AWWLabiaMinSwell01Range"); }
                    

                }
                catch
                {
                    SuperController.LogError("Something Went Wrong Loading " + path);
                }
            }
            else
            {

                SuperController.LogError(path + " is not a valid AWWalker.MultiPass class save file.");
                return;
            }
        }
        private float getSpreadDistance()
        {
            Vector3 chestPos = chest.followWhenOff.position;
            Vector3 lKneePos = lKnee.followWhenOff.position;
            Vector3 rKneePos = rKnee.followWhenOff.position;
            Vector3 direction = lKneePos - rKneePos;
            float rKneeTolKnee = direction.magnitude;
            direction = lKneePos - chestPos;
            float lKneeToChest = direction.magnitude;
            direction = rKneePos - chestPos;
            float rKneeToChest = direction.magnitude;
            float distance = rKneeTolKnee - (Mathf.Abs(lKneeToChest - rKneeToChest) * 2);
            return distance;
        }
        public void ApplySpreadValuesToMorphs()
        {

            float spread = getSpreadDistance();

            try { HoodModMorph.morphValue = Remap(spread, 0, 1, HoodModMorphChangeMin.val, HoodModMorphChangeMax.val); } catch { }
            try { labiaMajoraMorph.morphValue = Remap(spread, 0, 1, labiaMajoraMorphChangeMin.val, labiaMajoraMorphChangeMax.val); } catch { }
            try { LabMajRMidMorph.morphValue = Remap(spread, 0, 1, LabMajRMidMorphChangeMin.val, LabMajRMidMorphChangeMax.val); } catch { }
            try { LabMajLUpMorph.morphValue = Remap(spread, 0, 1, LabMajLUpMorphChangeMin.val, LabMajLUpMorphChangeMax.val); } catch { }
            try { LabMajLMidMorph.morphValue = Remap(spread, 0, 1, LabMajLMidMorphChangeMin.val, LabMajLMidMorphChangeMax.val); } catch { }
            try { LabMajLLowMorph.morphValue = Remap(spread, 0, 1, LabMajLLowMorphChangeMin.val, LabMajLLowMorphChangeMax.val); } catch { }
            try { LabMajRLowMorph.morphValue = Remap(spread, 0, 1, LabMajRLowMorphChangeMin.val, LabMajRLowMorphChangeMax.val); } catch { }
            try { LabMajRUpMorph.morphValue = Remap(spread, 0, 1, LabMajRUpMorphChangeMin.val, LabMajRUpMorphChangeMax.val); } catch { }
            try { labiaMinoraMorph.morphValue = Remap(spread, 0, 1, labiaMinoraMorphChangeMin.val, labiaMinoraMorphChangeMax.val); } catch { }
            try { AWW_Majora_LeftUpperTopMorph.morphValue = Remap(-spread, 0, 1, -AWW_Majora_LeftUpperTopMorphChangeMin.val, AWW_Majora_LeftUpperTopMorphChangeMax.val); } catch { }
            try { AWW_Majora_RightUpperTopMorph.morphValue = Remap(-spread, 0, 1, -AWW_Majora_RightUpperTopMorphChangeMin.val, AWW_Majora_RightUpperTopMorphChangeMax.val); }catch { }
            try { LabMinRUpMorph.morphValue = Remap(spread, 0, 1, LabMinRUpMorphChangeMin.val, LabMinRUpMorphChangeMax.val); } catch { }
            try { LabMinLUpMorph.morphValue = Remap(spread, 0, 1, LabMinLUpMorphChangeMin.val, LabMinLUpMorphChangeMax.val); } catch { }
            try { LabMinRMidMorph.morphValue = Remap(spread, 0, 1, LabMinRMidMorphChangeMin.val, LabMinRMidMorphChangeMax.val); } catch { }
            try { LabMinLMidMorph.morphValue = Remap(spread, 0, 1, LabMinLMidMorphChangeMin.val, LabMinLMidMorphChangeMax.val); } catch { }
            try { LabMinRLowMorph.morphValue = Remap(-spread, 0, 1, LabMinRLowMorphChangeMin.val, -LabMinRLowMorphChangeMax.val); } catch { }
            try { LabMinLLowMorph.morphValue = Remap(-spread, 0, 1, LabMinLLowMorphChangeMin.val, -LabMinLLowMorphChangeMax.val); } catch { }
            try { AWW_VagInternal_Size2.morphValue = Remap(spread, 0, 1, AWW_VagInternal_Size2ChangeMin.val, AWW_VagInternal_Size2ChangeMax.val); } catch { }
            try { AWW_Clitoris_Front_Back.morphValue = Remap(1, 0, 1, AWW_Clitoris_Front_BackRange.val, AWW_Clitoris_Front_BackRange.val); } catch { }
            try { AWW_Clitoris_HoodBack.morphValue = Remap(1, 0, 1, AWW_Clitoris_HoodBackRange.val, AWW_Clitoris_HoodBackRange.val); } catch { }
            try { AWW_Clitoris_Size.morphValue = Remap(1, 0, 1, AWW_Clitoris_SizeRange.val, AWW_Clitoris_SizeRange.val); } catch { }
            try { AWW_Clitoris_HoodSize.morphValue = Remap(1, 0, 1, AWW_Clitoris_HoodSizeRange.val, AWW_Clitoris_HoodSizeRange.val); } catch { }
            try { AWW_00_KegelMorph.morphValue = Remap(spread, 0, 1, -AWW_00_KegelMin.val, -AWW_00_KegelMax.val); } catch { }
            try { AWW_Anus_SpreadGape02Morph.morphValue = Remap(spread, 0, 1, AWW_Anus_SpreadGape02Min.val, AWW_Anus_SpreadGape02Max.val); } catch { }
            try { AWW_GenLabiaMajoraClosedAndSmoothMorph.morphValue = Remap(-spread, 0, 1, -AWW_GenLabiaMajoraClosedAndSmoothMorphMin.val, AWW_GenLabiaMajoraClosedAndSmoothMorphMax.val); } catch { }
            try { AWW_PuffyMajora_1Morph.morphValue = Remap(1, 0, 1, AWW_PuffyMajora_1Range.val, AWW_PuffyMajora_1Range.val); } catch { }
            try { AWWLabiaMinSwell01Morph.morphValue = Remap(1, 0, 1, AWWLabiaMinSwell01Range.val, AWWLabiaMinSwell01Range.val); } catch { }

        }
        public void ApplyMinValuesToMorphs()
        {
            try { HoodModMorph.morphValue = HoodModMorphChangeMin.val; } catch { }
            try { labiaMajoraMorph.morphValue = labiaMajoraMorphChangeMin.val; } catch { }
            try { LabMajRMidMorph.morphValue = LabMajRMidMorphChangeMin.val; } catch { }
            try { LabMajLUpMorph.morphValue = LabMajLUpMorphChangeMin.val; } catch { }
            try { LabMajLMidMorph.morphValue = LabMajLMidMorphChangeMin.val; } catch { }
            try { LabMajLLowMorph.morphValue = LabMajLLowMorphChangeMin.val; } catch { }
            try { LabMajRLowMorph.morphValue = LabMajRLowMorphChangeMin.val; } catch { }
            try { LabMajRUpMorph.morphValue = LabMajRUpMorphChangeMin.val; } catch { }
            try { labiaMinoraMorph.morphValue = labiaMinoraMorphChangeMin.val; } catch { }
            try { AWW_Majora_LeftUpperTopMorph.morphValue = -AWW_Majora_LeftUpperTopMorphChangeMin.val; } catch { }
            try { AWW_Majora_RightUpperTopMorph.morphValue = -AWW_Majora_RightUpperTopMorphChangeMin.val; } catch { }
            try { LabMinRUpMorph.morphValue = LabMinRUpMorphChangeMin.val; } catch { }
            try { LabMinLUpMorph.morphValue = LabMinLUpMorphChangeMin.val; } catch { }
            try { LabMinRMidMorph.morphValue = LabMinRMidMorphChangeMin.val; } catch { }
            try { LabMinLMidMorph.morphValue = LabMinLMidMorphChangeMin.val; } catch { }
            try { LabMinRLowMorph.morphValue = LabMinRLowMorphChangeMin.val; } catch { }
            try { LabMinLLowMorph.morphValue = LabMinLLowMorphChangeMin.val; } catch { }
            try { AWW_VagInternal_Size2.morphValue = AWW_VagInternal_Size2ChangeMin.val; } catch { }
            try { AWW_Clitoris_Front_Back.morphValue = AWW_Clitoris_Front_BackRange.val; } catch { }
            try { AWW_Clitoris_HoodBack.morphValue = AWW_Clitoris_HoodBackRange.val; } catch { }
            try { AWW_Clitoris_Size.morphValue = AWW_Clitoris_SizeRange.val; } catch { }
            try { AWW_Clitoris_HoodSize.morphValue = AWW_Clitoris_HoodSizeRange.val; } catch { }
            try { AWW_00_KegelMorph.morphValue = -AWW_00_KegelMin.val; } catch { }
            try { AWW_Anus_SpreadGape02Morph.morphValue = AWW_Anus_SpreadGape02Min.val; } catch { }
            try { AWW_GenLabiaMajoraClosedAndSmoothMorph.morphValue = -AWW_GenLabiaMajoraClosedAndSmoothMorphMin.val; } catch { }
            try { AWW_PuffyMajora_1Morph.morphValue = AWW_PuffyMajora_1Range.val; } catch { }
            try { AWWLabiaMinSwell01Morph.morphValue = AWWLabiaMinSwell01Range.val; } catch { }
        }
        public void ApplyMaxValuesToMorphs()
        {
            try { HoodModMorph.morphValue = HoodModMorphChangeMax.val; } catch { }
            try { labiaMajoraMorph.morphValue = labiaMajoraMorphChangeMax.val; } catch { }
            try { LabMajRMidMorph.morphValue = LabMajRMidMorphChangeMax.val; } catch { }
            try { LabMajLUpMorph.morphValue = LabMajLUpMorphChangeMax.val; } catch { }
            try { LabMajLMidMorph.morphValue = LabMajLMidMorphChangeMax.val; } catch { }
            try { LabMajLLowMorph.morphValue = LabMajLLowMorphChangeMax.val; } catch { }
            try { LabMajRLowMorph.morphValue = LabMajRLowMorphChangeMax.val; } catch { }
            try { LabMajRUpMorph.morphValue = LabMajRUpMorphChangeMax.val; } catch { }
            try { labiaMinoraMorph.morphValue = labiaMinoraMorphChangeMax.val; } catch { }
            try { AWW_Majora_LeftUpperTopMorph.morphValue = -AWW_Majora_LeftUpperTopMorphChangeMax.val; } catch { }
            try { AWW_Majora_RightUpperTopMorph.morphValue = -AWW_Majora_RightUpperTopMorphChangeMax.val; } catch { }
            try { LabMinRUpMorph.morphValue = LabMinRUpMorphChangeMax.val; } catch { }
            try { LabMinLUpMorph.morphValue = LabMinLUpMorphChangeMax.val; } catch { }
            try { LabMinRMidMorph.morphValue = LabMinRMidMorphChangeMax.val; } catch { }
            try { LabMinLMidMorph.morphValue = LabMinLMidMorphChangeMax.val; } catch { }
            try { LabMinRLowMorph.morphValue = LabMinRLowMorphChangeMax.val; } catch { }
            try { LabMinLLowMorph.morphValue = LabMinLLowMorphChangeMax.val; } catch { }
            try { AWW_VagInternal_Size2.morphValue = AWW_VagInternal_Size2ChangeMax.val; } catch { }
            try { AWW_Clitoris_Front_Back.morphValue = AWW_Clitoris_Front_BackRange.val; } catch { }
            try { AWW_Clitoris_HoodBack.morphValue = AWW_Clitoris_HoodBackRange.val; } catch { }
            try { AWW_Clitoris_Size.morphValue = AWW_Clitoris_SizeRange.val; } catch { }
            try { AWW_Clitoris_HoodSize.morphValue = AWW_Clitoris_HoodSizeRange.val; } catch { }
            try { AWW_00_KegelMorph.morphValue = -AWW_00_KegelMax.val; } catch { }
            try { AWW_Anus_SpreadGape02Morph.morphValue = AWW_Anus_SpreadGape02Max.val; } catch { }
            try { AWW_GenLabiaMajoraClosedAndSmoothMorph.morphValue = -AWW_GenLabiaMajoraClosedAndSmoothMorphMax.val; } catch { }
            try { AWW_PuffyMajora_1Morph.morphValue = AWW_PuffyMajora_1Range.val; } catch { }
            try { AWWLabiaMinSwell01Morph.morphValue = AWWLabiaMinSwell01Range.val; } catch { }
        }
        private void createSPACER(float height)
        {
            CreateSpacer(false).height = height;
            CreateSpacer(true).height = height;
        }
        private void createLeftSPACER(float height)
        {
            CreateSpacer(false).height = height;
        }
        private void createRightSPACER(float height)
        {
            CreateSpacer(true).height = height;
        }
        private void createTitle(string textTitle, Color tColor, string info, Color iColor)
        {
                UIDynamicButton bTitleLMJMax = CreateButton(textTitle, false);
                UIDynamicButton bTitleLMJMin = CreateButton(info, true);
                bTitleLMJMax.textColor = tColor;
                bTitleLMJMax.textColor = iColor; bTitleLMJMin.buttonText.fontSize = 20;
                bTitleLMJMax.buttonColor = cClear;
                bTitleLMJMin.buttonColor = cClear;
                bTitleLMJMax.buttonText.fontSize = 40;

        }
        private void createMorphSLIDER(JSONStorableFloat jFloat, Color jColor, bool isRightSide)
        {
            if (isRightSide) { jColor = cBlue; }
            else { jColor = cMagenta; };

            var sldSlider = CreateSlider(jFloat, isRightSide) ;
            try { sldSlider.label = sldSlider.label.Replace("_", " ").Replace("LabMajR", "Right ").Replace("LabMajL", "Left ").Replace("LabMinR", "Right ").Replace("LabMinL", "Left "); } catch { };
            try { sldSlider.labelText.color = jColor; } catch { };
            try { sldSlider.labelText.fontSize = 23; } catch { };
        }
        private void createStdSLIDER(JSONStorableFloat jFloat, Color jColor, int fontSize, bool isRightSide)
        {
            var sldSlider = CreateSlider(jFloat, isRightSide);
            try { sldSlider.name = sldSlider.name.Replace("_", "").Replace("AWW", ""); } catch { };
            try { sldSlider.labelText.color = jColor; } catch { };
            try { sldSlider.labelText.fontSize = fontSize; } catch { };
            

        }
        private float Remap(float inVal, float min1, float max1, float min2, float max2)
        {
                var ratio = (max2 - min2) / (max1 - min1);  //determine distance between open and close
                var c = min2 - ratio * min1;
                var mFactor = ratio * inVal + c;

            if (CurveEnabled.val)
            {
                if ((ratio * inVal + c) < 0)
                {
                    return OverallIntensity.val * (mFactor * mFactor * -1f);
                }
                else
                {
                    return OverallIntensity.val * (mFactor * mFactor * 1f);
                }
            }

            else
            {
                return OverallIntensity.val * mFactor;
            };

        }
        public void zeroAllSettings()
        {
            sIsEnabled.val = true;
            CurveEnabled.val = true;
            OverallIntensity.val = 1f;
            LabMinRUpMorphChangeMin.val = 0f;
            LabMinRUpMorphChangeMax.val = 0f;
            LabMinRMidMorphChangeMin.val = 0f;
            LabMinRMidMorphChangeMax.val = 0f;
            LabMinRLowMorphChangeMin.val = 0f;
            LabMinRLowMorphChangeMax.val = 0f;
            LabMinLUpMorphChangeMin.val = 0f;
            LabMinLUpMorphChangeMax.val = 0f;
            LabMinLMidMorphChangeMin.val = 0f;
            LabMinLMidMorphChangeMax.val = 0f;
            LabMinLLowMorphChangeMin.val = 0f;
            LabMinLLowMorphChangeMax.val = 0f;
            LabMajRUpMorphChangeMin.val = 0f;
            LabMajRUpMorphChangeMax.val = 0f;
            LabMajRMidMorphChangeMin.val = 0f;
            LabMajRMidMorphChangeMax.val = 0f;
            LabMajRLowMorphChangeMin.val = 0f;
            LabMajRLowMorphChangeMax.val = 0f;
            LabMajLUpMorphChangeMin.val = 0f;
            LabMajLUpMorphChangeMax.val = 0f;
            LabMajLMidMorphChangeMin.val = 0f;
            LabMajLMidMorphChangeMax.val = 0f;
            LabMajLLowMorphChangeMin.val = 0f;
            LabMajLLowMorphChangeMax.val = 0f;
            labiaMinoraMorphChangeMin.val = 0f;
            labiaMinoraMorphChangeMax.val = 0f;
            labiaMajoraMorphChangeMin.val = 0f;
            labiaMajoraMorphChangeMax.val = 0f;
            HoodModMorphChangeMin.val = 0f;
            HoodModMorphChangeMax.val = 0f;
            AWW_VagInternal_Size2ChangeMin.val = 0f;
            AWW_VagInternal_Size2ChangeMax.val = 0f;
            AWW_PuffyMajora_1Range.val = 0f;
            AWW_Majora_RightUpperTopMorphChangeMin.val = 0f;
            AWW_Majora_RightUpperTopMorphChangeMax.val = 0f;
            AWW_Majora_LeftUpperTopMorphChangeMin.val = 0f;
            AWW_Majora_LeftUpperTopMorphChangeMax.val = 0f;
            AWW_GenLabiaMajoraClosedAndSmoothMorphMin.val = 0f;
            AWW_GenLabiaMajoraClosedAndSmoothMorphMax.val = 0f;
            AWW_Clitoris_SizeRange.val = 0f;
            //AWW_Clitoris_SizeMax.val = 0f;
            AWW_Clitoris_HoodSizeRange.val = 0f;
            //AWW_Clitoris_HoodSizeMax.val = 0f;
            AWW_Clitoris_HoodBackRange.val = 0f;
            //AWW_Clitoris_HoodBackMax.val = 0f;
            AWW_Clitoris_Front_BackRange.val = 0f;
            //AWW_Clitoris_Front_BackMax.val = 0f;
            AWW_Anus_SpreadGape02Min.val = 0f;
            AWW_Anus_SpreadGape02Max.val = 0f;
            AWW_00_KegelMin.val = 0f;
            AWW_00_KegelMax.val = 0f;


        }
        private void createDefaultFile()
        {
            //Things to do
        }
        private void saveAsNewDefaultFile()
        {
            //Things to do
        }
        private void restoreOriginalDefaults()
        {
            //Things to do
        }
    }


}

